#!/bin/bash

# We're going to run this in the MacTeX working directory...
WORK=`pwd`

export COPYFILE_DISABLE=true

if [[ -d RawCode/2021-New/universal-darwin ]]; then
	rm -R RawCode/2021-New/universal-darwin
fi

mkdir RawCode/2021-New/universal-darwin

if [[ -d RawCode/2021-New/universal-darwin.tar.xz ]]; then
	rm -R RawCode/2021-New/universal-darwin.tar.xz
fi


echo CHANGED BINARIES

cd RawCode/2021-New/x86_64-apple-darwin18
files=`ls`
for f in $files; do
	if  ! [[ -L $f ]] &&  [[ "$(file $f)" = "$f: Mach-O 64-bit executable x86_64" ]]; then
		
		if [ -e ../../2021-Old/x86_64-apple-darwin18/$f ]; then
			cmp -s ../../2021-Old/x86_64-apple-darwin18/$f $f
			status=$?
			if ! [[ $status = 0 ]]; then
				echo $f
				if [[ -e ../aarch64-apple-darwin20/$f ]]; then
					lipo $f   ../aarch64-apple-darwin20/$f -create -output ../universal-darwin/$f
				else
					cp $f ../universal-darwin/$f
				fi
				
				if [[ $f = mf ]] || [[ $f = xdvi-xaw ]] || [[ $f = dvisvgm ]]; then
					codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/gs-X11.entitlements  ../universal-darwin/$f
				elif [[ $f = luahbtex ]] || [[ $f = luajithbtex ]] || [[ $f = luatex ]] || [[ $f = luajittex ]]; then
					codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  ../universal-darwin/$f
				else
					codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime ../universal-darwin/$f
				fi
			else
				cp ../../2021-Old/universal-darwin/$f ../universal-darwin/$f
			fi
		else
			echo BRAND NEW
			echo $f
			if [[ -e ../aarch64-apple-darwin20/$f ]]; then
					lipo $f   ../aarch64-apple-darwin20/$f -create -output ../universal-darwin/$f
				else
					cp $f ../universal-darwin/$f
				fi
			if [[ $f = mf ]] || [[ $f = xdvi-xaw ]] || [[ $f = dvisvgm ]]; then
				codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/gs-X11.entitlements  ../universal-darwin/$f
			elif [[ $f = luahbtex ]] || [[ $f = luajithbtex ]] || [[ $f = luatex ]] || [[ $f = luajittex ]]; then
				codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  ../universal-darwin/$f
			else
				codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime ../universal-darwin/$f
			fi
		fi
	fi
		
			
done

echo END OF CHANGED BINARIES

echo ASYMPTOTE

cmp -s ../../2021-Old/asy-Intel ../asy-Intel
status=$?
if ! [[ $status = 0 ]]; then
	lipo ../asy-Intel  ../asy-Arm  -create -output ../universal-darwin/asy
	codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime ../universal-darwin/asy
else
	cp ../../2021-Old/asy ../universal-darwin/asy
fi

cd ../universal-darwin
ln -s ../../texmf-dist/asymptote/GUI/xasy.py xasy
cd ../x86_64-apple-darwin18

echo COPY ALL OTHER SCRIPTS AND LINKS

echo LINKS

for f in $files; do
	if [[ -L $f ]]; then
		cp -R $f ../universal-darwin/$f
	fi
done

echo SCRIPTS

for f in $files; do
	if  ! [[ -L $f ]] && ! [[ "$(file $f)" = "$f: Mach-O 64-bit executable x86_64" ]] ; then
		cp $f ../universal-darwin/$f
	fi
done



echo END OF CHANGED SCRIPTS

cd ../


echo COMPRESSING

(cd  universal-darwin; tar cf - . ) > universal-darwin.tar

../xz --compress universal-darwin.tar



