#!/bin/bash

# We're going to run this in the MacTeX working directory...
WORK=`pwd`

cd ${WORK}/root/usr/local/texlive/2021/tlpkg/installer

cd lz4
codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime lz4.x86_64-darwin
cd ..

cd wget
codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime wget.x86_64-darwin
cd ..

cd xz
codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime xz.x86_64-darwin
cd ..


cd ${WORK}/root/usr/local/texlive/2021/bin/universal-darwin

# rm biber

COUNT=0
files=`ls`
for f in $files; do
	if ! [[ -L $f ]] && [[ "$(file $f)" == "$f: Mach-O universal binary"* ]]; then
		codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime $f
		COUNT=$((COUNT+1))
	fi
done

for f in $files; do
	if ! [[ -L $f ]] && [[ "$(file $f)" = "$f: Mach-O 64-bit executable x86_64" ]]; then
		codesign -s   "Developer ID Application: Richard Koch" --force --timestamp --options=runtime $f
		COUNT=$((COUNT+1))
	fi
done


codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/gs-X11.entitlements  mf

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/gs-X11.entitlements  xdvi-xaw

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/gs-X11.entitlements  dvisvgm

# Fix luatex entitlements

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  luahbtex

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  luajithbtex

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  luatex

codesign -s   "Developer ID Application: Richard Koch"  --force --timestamp --options=runtime --entitlements=${WORK}/luahbtex.entitlements  luajittex

# Fix other problems

cd ${WORK}/root/usr/local/texlive/2021/texmf-dist/doc/support/ctan-o-mat
mv ctan-o-mat.pkg ctan-o-mat.txt

# cd ${WORK}/root/usr/local/texlive/2021/texmf-dist/doc/latex/codepage
# rm demo.zip

cd ${WORK}/root/usr/local/texlive/2021/texmf-dist/source/latex/stellenbosch
rm USlogos-4.0-src.zip 
# (Ultimately I just removed USEngLogo-top.cdr and USEngLogo.cdr)

# End fixes

echo $COUNT
cd ../../

